<template>
    <NuxtLayout :name="'dashboard'">
        <div class="container p-8">
            <!-- <Toast :visible="toastVisible" :title="toastTitle" :message="toastMessage" /> -->
            <CustomTable :tableName="tableName" :currentPage="currentPage" :limitPerPage="itemPerPage" :heads="heads"
                :items="files" :addPath="!isWarga ? '/funding/new' : ''" @on-search="search"
                @approve-funding="approveFunding" @reject-funding="rejectFunding" @page-change="pageUpdate" />
        </div>
    </NuxtLayout>
</template>

<script lang="ts">

definePageMeta({
    middleware: ["auth"],
});

export default {
    layout: "dashboard",
    data() {
        return {
            toastVisible: false,
            toastTitle: "",
            toastMessage: "",
            tableName: "Funding",
            isLoading: false,
            currentPage: 1,
            itemPerPage: 10,
            heads: [
                "No",
                "Title",
                "Nominal",
                "Dibuat Tanggal",
                "Total Terbayar",
                "Action",
            ],
            files: [],
        };
    },
    mounted() {
        this.fetchData();
    },
    computed: {
        isWarga: () => {
            const userStore = useUserDataStore();
            return userStore.role === 'warga' ? true : false;
        }
    },
    methods: {
        fetchData(query: string = '') {
            this.isLoading = true;
            const userDataStore = useUserDataStore();
            const userId = userDataStore.id;
            const toastStore = useToastStore();
            const accessToken = localStorage.getItem("access_token");
            const config = useRuntimeConfig();
            this.$api
                .get(`/funding?search=${query}&page=${this.currentPage}&limit=${this.itemPerPage}`, {
                    headers: {
                        'Authorization': `Bearer ${accessToken}`,
                    },
                })
                .then((response) => {
                    console.log(response.data);
                    let response_data = response.data;
                    response_data.map((item: any) => {
                        item.created_at = new Date(item.created_at).toISOString().split('T')[0];
                        item.total_paid = `${item.nominal * item.payments.length} (${item.payments.length} orang)`;
                        let isPaid = false;
                        item.payments.forEach((payment: any) => {
                            if (userId == payment.owner.id && payment.status != 'rejected') {
                                isPaid = true;
                            }
                        });
                        item.action = [
                            {
                                icon: "material-symbols:edit-outline",
                                color: "bg-blue-500",
                                route: `/funding/${item.id}`,
                                disabled: this.isWarga || item.total_paid != 0,
                            },
                            {
                                icon: "streamline:money-cash-bill-3-accounting-billing-payment-finance-cash-currency-money-bill",
                                color: "bg-green-500",
                                route: `/funding/${item.id}/payment`,
                                disabled: this.isWarga
                            },
                            {
                                icon: "material-symbols:delete-outline-rounded",
                                color: "bg-red-500",
                                callback: 'delete-file',
                                disabled: this.isWarga || item.total_paid != 0,
                            },
                            {
                                icon: "bxs:report",
                                color: "bg-yellow-500",
                                route: `/funding/${item.id}/report`,
                                disabled: this.isWarga || isPaid,
                            },
                            {
                                icon: "line-md:document-report",
                                color: "bg-blue-500",
                                route: `/funding/${item.id}/outcome`,
                                disabled: !this.isWarga,
                            },
                            {
                                icon: "streamline:money-atm-card-2-deposit-money-payment-finance-atm-withdraw",
                                color: "bg-yellow-500",
                                route: `/funding/${item.id}/pay`,
                                disabled: !this.isWarga || isPaid,
                            },
                        ];
                        delete item.payments;
                        delete item.owner;
                        delete item.report;
                    });
                    this.files = response_data;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    toastStore.showToast(message, 'danger');
                }).finally(() => {
                    this.isLoading = false;
                })
        },
        search(query: string) {
            this.fetchData(query);
        },
        pageUpdate(page: number) {
            this.currentPage = page;
            this.fetchData();
        },
        approveFunding(id: number) {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.put(`/funding/${id}/approve`, {}, {
                headers: {
                    'Authorization': `Bearer ${accessToken}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.fetchData();
                    toastStore.showToast(`Funding ${title} has been approved`, 'success');
                    this.isLoading = false;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                    this.isLoading = false;
                })
        },
        rejectFunding(id: number) {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.put(`/funding/${id}/reject`, {}, {
                headers: {
                    'Authorization': `Bearer ${accessToken}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.fetchData();
                    toastStore.showToast(`Funding ${title} has been rejected`, 'success');
                    this.isLoading = false;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                    this.isLoading = false;
                })
        },
    },
};
</script>
